//------------------------------------------------------------------------------
// <copyright company="Telligent Systems">
//     Copyright (c) Telligent Systems Corporation.  All rights reserved.
// </copyright> 
//------------------------------------------------------------------------------

using System.Xml;
using CommunityServer.Components;

namespace CommunityServer.Blogs.Components
{
	/// <summary>
	/// Summary description for TrackbackModule.
	/// </summary>
	public class TrackbackModule : ICSModule
	{
		public TrackbackModule()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public void Init(CSApplication csa, XmlNode node)
		{
			csa.PostPostUpdate +=new CSPostEventHandler(csa_AfterProcessPost);
		}

		private void csa_AfterProcessPost(IContent content, CSPostEventArgs e)
		{
			if(e.ApplicationType == ApplicationType.Weblog)
			{
				WeblogPost wp = content as WeblogPost;

				if(wp != null && (wp.BlogPostType == BlogPostType.Post || wp.BlogPostType == BlogPostType.Article) && e.State != ObjectState.Delete)
				{
					if(wp.IsPostEnabled && wp.Weblog.ValidateTrackBacks(wp))
					{
						TrackBackNotificationProxy.Track(wp,true);
					}
				}
			}
		}
	}
}
